var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { KaCustomFragment, template } from "@kasimirjs/embed";
import { random_string } from "../functions";
let html = `
<div class="row g-3 align-items-center">
  <div class="col-auto">
    <label ka.attr.for="config.id" class="col-form-label">[[ config.title ]]</label>
  </div>
  <div class="col-auto">
    <input ka.if="config.type !== 'select' && config.type !== 'textarea'" ka.attr.readonly="config.readonly === true" ka.attr.type="config.type" ka.id="config.id" ka.bind="%%bind%%" class="form-control" aria-describedby="passwordHelpInline">
  </div>
  <div class="col-auto">
    <span id="passwordHelpInline" class="form-text">
      Must be 8-20 characters long.
    </span>
  </div>
</div>

`;
const KitFormInputDefaults = {
    title: "",
    type: "text",
    id: null
};
let KitFormInput = class KitFormInput extends KaCustomFragment {
    /**
     * Example:
     *
     * new KitFormInput("$scope.name", {title: "Name:"});
     *
     * @param bindSelector
     * @param config
     */
    constructor(bindSelector, config) {
        super();
        this.bindSelector = bindSelector;
        config = Object.assign(Object.assign({}, KitFormInputDefaults), config);
        if (config.id === null) {
            config.id = random_string();
        }
        let scope = this.init({
            config,
            bindValue: bindSelector
        });
    }
    init(scope) {
        if (typeof this.constructor["html"] !== "undefined")
            this["html"] = this.constructor['html'].replace("%%bind%%", this.bindSelector);
        return super.init(scope);
    }
};
KitFormInput = __decorate([
    template(html),
    __metadata("design:paramtypes", [String, Object])
], KitFormInput);
export { KitFormInput };
